function BoeingPFD() {}

var svgFilename2 = 'apps/BoeingPFD/737PFD.svg';

BoeingPFD.prototype.initialize = function () {
    if(this.objc) this.objc.remove();

    this.objc = $('<object id="svgObject2" type="image/svg+xml" data="' + svgFilename2 + '?t=' + Date.now() + '" width="512" height="522" border="0"/>').appendTo(this.rootElement);
    this.objc.css({
        width: '100%',
        height: '100%'
    });
    
    this.objContainer = this.objc[0];
    this.svg = null;
	// we need to wait for the SVG to load before we can do anything 
    var self = this;
    this.objContainer.addEventListener("load", function() {
        self.svg = this.contentDocument;
    });
    
	beamng.sendActiveObjectLua('acc_e = newExponentialSmoothing(80); aoa_e = newExponentialSmoothing(15);');
	callEngineLuaFuncCallback("scenetree.theTerrain.getPosition().z", callback5);
};

var ias = 0;
var acc = 0;
var old_ias = 0;
var old_alt;
var aoa = 0;
var vsi = 0;
var pt = 0;
var track = 0;
var ralt = "";
var w_z=null;

var a_vsi = ["0"];

function callback1(res){
    ias = res/0.5144;
	callLuaFuncCallback('acc_e:get('+(ias-old_ias)+')', callback2);
	old_ias = ias;
}

function callback2(res){
    acc = res;
}

function callback3(res){
    aoa = res;
}

function callback4(res){
	track = res;
}

function callback5(res){
	w_z=res;
	console.log("H");
}

function callback6(res){
	if (res && (w_z!=null)) {
		ralt=(old_alt-(res+w_z))*3.28;
	}else{
		ralt="";
	}
}

BoeingPFD.prototype.update = function(streams){
	ct = performance.now();
	var dt = (ct - pt)/1000;
	pt = ct;
	var cvsi = 0;
	if (old_alt) cvsi = (streams.sensors.position.z-old_alt)/dt*3.28*60;
	
	a_vsi.push(cvsi);
	if (a_vsi.length>60) a_vsi.shift();
	
	callLuaFuncCallback('(obj:getDirectionVector():dot(obj:getVelocity() - obj:getFlow())) * math.sqrt(obj:getDensityatNode(0) / 1.225)', callback1);
	callLuaFuncCallback('aoa_e:get((vec3(obj:getDirectionVector())-vec3(obj:getVelocity()):normalized()).z)', callback3);
	callLuaFuncCallback('math.atan2(obj:getVelocity().x,obj:getVelocity().y)*180/math.pi', callback4);
	callGameEngineFuncCallback("getTerrainHeight("+streams.sensors.position.x+","+streams.sensors.position.y+")", callback6);
	streams.ias = ias;
	streams.acc = acc;
	streams.aoa = aoa;
	streams.vsi = a_vsi.reduce(function(a, b){return a+b;})/a_vsi.length;
	streams.track = track;
	streams.ralt = ralt;
    if(this.svg && this.svg.update) {
        this.svg.update(streams);
    }
	old_alt=streams.sensors.position.z;
	
};

BoeingPFD.prototype.onFileChanged = function(data) {
    if(data.filename == 'html/' + svgFilename2) {
        this.initialize();
    }
};

BoeingPFD.prototype.onVehicleChange = function() {
	old_ias=0;
	old_alt=0;
    beamng.sendActiveObjectLua('acc_e = newExponentialSmoothing(80); aoa_e = newExponentialSmoothing(15);');
	w_z=null;
	callEngineLuaFuncCallback("scenetree.theTerrain.getPosition().z", callback5);
};

BoeingPFD.prototype.onVehicleReset = function() {
	old_ias=0;
	old_alt=0;
    beamng.sendActiveObjectLua('acc_e = newExponentialSmoothing(80); aoa_e = newExponentialSmoothing(15);');
};

BoeingPFD.prototype.onChangeApAlt = function(ft) {
	this.svg.ChangeApAlt(ft);
};